
module SeedData

  class DataManager

    attr_reader :data_sets
    attr_reader :builder
    attr_reader :environment_variable

    ANY_ENVIRONMENT = 'any'.freeze

    def initialize(options)
      @data_sets = []

      @environment_variable = options[:environment_variable] || 'RACK_ENV'

      if options[:builder] == nil
        raise SeedData::DataBuilderNotSpecifiedException.new
      end

      @builder = options[:builder]
    end

    def register(options)

      if !options.has_key?(:environment)
        options[:environment] = ANY_ENVIRONMENT
      end

      if !options.has_key?(:data_set)
        raise SeedData::InvalidRegistrationException.new('Invalid registration option, :data_set must be specified.')
      end

      @data_sets << options

      return true
    end

    def load

      puts 'SeedData:: Load.'

      valid_data_sets.each do |itm|

        puts "SeedData:: Loading data set: #{itm[:data_set]}"

        @builder.build(itm[:data_set])

      end

      puts 'SeedData:: Loading complete.'

      return true

    end

    def valid_data_sets
      return @data_sets.select { |i| i[:environment] == ENV[@environment_variable] || i[:environment] == ANY_ENVIRONMENT }
    end

  end

end